(****************************************************************************)
(* Unit MIXSB Copyright (c) 1997 by ToMaS                                   *)
(* Use only on compatible Creative Labs Sound Blaster 8bit or 16 bit        *)
(****************************************************************************)
Unit MIXSB;
Interface
  Const Base = $220;
  Type LR = Record
              L, R: Byte;
            End;
  Function AdlibExists: Boolean; { if adlib is present  }
  Procedure Sbw(x,y:byte);       { sb write             }
  Function Sbr(x:byte):byte;     { sb read              }
  Procedure Detect816;           { if sb is 8 or 16 bit }
  Procedure GetMixVal;           { get mixer settings   }
  Procedure SetMixVal;           { set mixer settings   }
  Var MIX16: Record
               Master: LR;{0..31}
               Voice : LR;{0..31}
               Line  : LR;{0..31}
               CD    : LR;{0..31}
               Midi  : LR;{0..31}
               Power : LR;{0..3}
               Treble: LR;{0..15}
               Bass  : LR;{0..15}
               Mic   : Byte;{0..31}
             End;
      MIX8 : Record
               Master: LR;{0..15}
               Voice : LR;{0..15}
               Line  : LR;{0..15}
               CD    : LR;{0..15}
               Midi  : LR;{0..15}
               Mic   : Byte;{0..7}
             End;
  SB816: Byte;                    { most be 8 or 16 }
Implementation
Uses CRT;
Function AdlibExists: Boolean;
  Const AdlibFmAddres=$220;
        AdlibFmData=$221;

  Var Stat1, Stat2: byte;
  Function ReadFm: Integer; Assembler;
    Asm
       xor ax,ax
       mov dx,adlibfmaddres
       in  al,dx
    End;
  Procedure WriteFm(Reg, Value: Integer); Assembler;
    Asm
       mov dx,adlibfmaddres
       mov ax,reg
       out dx,al
       mov cx,6
    @1:
       in  al,dx
       loop @1
       mov dx,adlibfmdata
       mov ax,value
       out dx,al
       mov cx,35
    @2:
       in  al,dx
       loop @2
    End;
  Begin
    WriteFm($04,$60);
    WriteFm($04,$80);
    Stat1:=ReadFm;
    WriteFm($02,$ff);
    WriteFm($04,$21);
    Delay(100);
    Stat2:=ReadFm;
    WriteFm($04,$60);
    WriteFm($04,$80);
    If (((Stat1 And $e0)=0) And ((Stat2 And $e0)=$c0)) Then
      AdlibExists:=True
     Else AdlibExists:=False;
  End;
Procedure Sbw(x,y:byte);
  Begin
    port[Base+4]:=x;port[Base+5]:=y;
  End;
Function Sbr(x:byte):byte;
  Var y:byte;
  Begin
    port[Base+4]:=x;sbr:=port[Base+5];
  End;
Procedure Detect816;
  Var a, c: Byte; b: Byte;
  Begin
    a:=SbR($36);
    b:=128;If b=a Then b:=64;
    SbW($36,b);
    If b=SbR($36) Then SB816:=16
    Else SB816:=8;
    SbW($36,a);
  end;
Procedure GetMixVal;
  Var a, b, c: Byte;
  Begin
    Case SB816 Of
       8:Begin
           a:=sbr($22);b:=a shr 4;c:=((a or 240) xor 240);
           Mix8.Master.L:=b;
           Mix8.Master.R:=c;

           a:=sbr($04);b:=a shr 4;c:=((a or 240) xor 240);
           Mix8.Voice.L:=b;
           Mix8.Voice.R:=c;

           a:=sbr($2E);b:=a shr 4;c:=((a or 240) xor 240);
           Mix8.Line.L:=b;
           Mix8.Line.R:=c;

           a:=sbr($28);b:=a shr 4;c:=((a or 240) xor 240);
           Mix8.CD.L:=b;
           Mix8.CD.R:=c;

           a:=sbr($26);b:=a shr 4;c:=((a or 240) xor 240);
           Mix8.Midi.L:=b;
           Mix8.Midi.R:=c;

           a:=sbr($0A);b:=a shr 4;c:=((a or 240) xor 240);
           Mix8.Mic:=c;
         End;
      16:Begin
           a:=Sbr($30);a:=a shr 3;Mix16.Master.L:=a;
           a:=Sbr($31);a:=a shr 3;Mix16.Master.R:=a;

           a:=Sbr($32);a:=a shr 3;Mix16.Voice.L:=a;
           a:=Sbr($33);a:=a shr 3;Mix16.Voice.R:=a;

           a:=Sbr($38);a:=a shr 3;Mix16.Line.L:=a;
           a:=Sbr($39);a:=a shr 3;Mix16.Line.R:=a;

           a:=Sbr($36);a:=a shr 3;Mix16.CD.L:=a;
           a:=Sbr($37);a:=a shr 3;Mix16.CD.R:=a;

           a:=Sbr($34);a:=a shr 3;Mix16.Midi.L:=a;
           a:=Sbr($35);a:=a shr 3;Mix16.Midi.R:=a;

           a:=Sbr($41);a:=a shr 6;Mix16.Power.L:=a;
           a:=Sbr($42);a:=a shr 6;Mix16.Power.R:=a;

           a:=Sbr($44);a:=a shr 4;Mix16.Treble.L:=a;
           a:=Sbr($45);a:=a shr 4;Mix16.Treble.R:=a;

           a:=Sbr($46);a:=a shr 4;Mix16.Bass.L:=a;
           a:=Sbr($47);a:=a shr 4;Mix16.Bass.R:=a;

           a:=Sbr($3A);a:=a shr 3;Mix16.Mic:=a;
         End;
    End;
  End;
Procedure SetMixVal;
  Var a, b, c: Byte;
  Begin
    Case SB816 Of
       8:Begin
           b:=Mix8.Master.L;
           c:=Mix8.Master.R;
           a:=0;a:=a or (b shl 4) or c;sbw($22,a);

           b:=Mix8.Voice.L;
           c:=Mix8.Voice.R;
           a:=0;a:=a or (b shl 4) or c;sbw($04,a);

           b:=Mix8.Line.L;
           c:=Mix8.Line.R;
           a:=0;a:=a or (b shl 4) or c;sbw($2E,a);

           b:=Mix8.CD.L;
           c:=Mix8.CD.R;
           a:=0;a:=a or (b shl 4) or c;sbw($28,a);

           b:=Mix8.Midi.L;
           c:=Mix8.Midi.R;
           a:=0;a:=a or (b shl 4) or c;sbw($26,a);

           c:=Mix8.Mic;
           a:=0;a:=a or c;sbw($0A,a);
         End;
      16:Begin
           a:=Mix16.Master.L;a:=a shl 3;Sbw($30,a);
           a:=Mix16.Master.R;a:=a shl 3;Sbw($31,a);

           a:=Mix16.Voice.L;a:=a shl 3;Sbw($32,a);
           a:=Mix16.Voice.R;a:=a shl 3;Sbw($33,a);

           a:=Mix16.Line.L;a:=a shl 3;Sbw($38,a);
           a:=Mix16.Line.R;a:=a shl 3;Sbw($39,a);

           a:=Mix16.CD.L;a:=a shl 3;Sbw($36,a);
           a:=Mix16.CD.R;a:=a shl 3;Sbw($37,a);

           a:=Mix16.Midi.L;a:=a shl 3;Sbw($34,a);
           a:=Mix16.Midi.R;a:=a shl 3;Sbw($35,a);

           a:=Mix16.Power.L;a:=a shl 6;Sbw($41,a);
           a:=Mix16.Power.R;a:=a shl 6;Sbw($42,a);

           a:=Mix16.Treble.L;a:=a shl 4;Sbw($44,a);
           a:=Mix16.Treble.R;a:=a shl 4;Sbw($45,a);

           a:=Mix16.Bass.L;a:=a shl 4;Sbw($46,a);
           a:=Mix16.Bass.R;a:=a shl 4;Sbw($47,a);

           a:=Mix16.Mic;a:=a shl 3;Sbw($3A,a);
         End;
    End;
  End;

Begin

End.